#include <stdio.h>
#include <io.h>
#include <dos.h>
#include <direct.h>
#include <sys\stat.h>
#include <sys\types.h>
#include <malloc.h>
#include <fcntl.h>
#include <string.h>

// 

#define YEAR(t)   ((((t) & 0xFE00) >> 9) + 80)
#define MONTH(t)  (((t) & 0x01E0) >> 5)
#define DAY(t)    ((t) & 0x001F)
#define HOUR(t)   (((t) & 0xF800) >> 11)
#define MINUTE(t) (((t) & 0x07E0) >> 5)
#define SECOND(t) (((t) & 0x001F) << 1)

#define _YEAR(t)   (((t) - 80) << 9)
#define _MONTH(t)  ((t) << 5)
#define _DAY(t)    (t)
#define _HOUR(t)   ((t) << 11)
#define _MINUTE(t) ((t) << 5)
#define _SECOND(t) ((t) >> 1)

#define CREATE_NEW_DIR 0
#define UPDATE_OLD_DIR 1

#define TRUE 1
#define FALSE 0

// 

char magic_bytes_end[] = "Elib";
char magic_bytes_list[] = "Flst";
char joker[] = "*.*";
char tmp_file[] = "~ELIB~~~.TMP";

// 

char*                 joker_pointer=joker;
char*                 nully=NULL; // pointer after joker_pointer MUST be NULL
char**                files_to_check=NULL;
short int             files_nr=0;
short int             arc_handle=-1;
short int             tmp_handle=-1;

struct filelist_entry* filelist=NULL;
struct filelist_entry* cmdfiles=NULL;

struct filelist_entry* filepointer=NULL;
char** cmdpointer=NULL;

struct find_t  fileinfo;

// 

char update_pathnames = FALSE;
char exclude_pathnames = FALSE;

// 

struct fileendheader_
{
       long filelistheader;
       char magic_bytes[4];
} fileendheader;

struct filelistheader_
{
       char magic_bytes[4];
       long filelist;
       long filenames;
       short int nr_of_files;
       long len_of_exec;
       short len_of_strings;
} filelistheader;

struct filedate
{
       char year;
       char month;
       char day;
};

struct filetime
{
       char hour;
       char minute;
       char second;
};

struct filelist_entry
{
       long filename;
       long filepos;
       long len;
       struct filedate date;
       struct filetime time;
       struct filelist_entry* next;
#ifndef __386__
       short int res1;   // filelist_entry* is in 386-mode 32bit wide
#endif
};

// 
char get_yes_or_no()
{
   short int a=0;

   while (a != 'y' && a != 'j' && a != 'n')
   {
      a = getch();
      if (a == 0) getch();
   }
   printf("%c\n",a);
   if (a == 'n') return(0);
   return(1);
}
// 
void* my_alloc ( size_t size )
{
      void *ptr;
      ptr = (void*) malloc (size);
      if (ptr == NULL)
      {
          printf("Out of memory! (malloc) (memory wanted: %li)\n", (long) size);
          exit(-1);
      }
      return(ptr);
}
void* my_realloc ( void* old_p, size_t size )
{
      void *ptr;
      ptr = (void*) realloc (old_p, size);
      if (ptr == NULL)
      {
          printf("Out of memory! (realloc) (memory wanted: %li)\n", (long) size);
          exit(-1);
      }
      return(ptr);
}
// 
char* cut_of_path(char* filename)
{
      char* p;
      if ((p = strrchr((char*) filename, '\\')) != NULL) return(p + 1);
      if (filename[1] == ':') return(filename + 2);
      return(filename);
}
// 

void _dos_read_max(int handle, void __far *buffer, long int size,
                   unsigned long int* bytes)
{
     long s;
     void __far *buffer2;
     unsigned int byte;

     buffer2 = buffer;
     s = size;
     (*bytes) = 0;
     while (s > 65520)
     {
           _dos_read(handle, buffer2, 65520, &byte);
           (*bytes) += byte;
           if (byte < 65520) { s = 0; break; }
           buffer2 = (char huge*) ((unsigned long) buffer2 + ((unsigned long) 4095 << 16));
           s -= 65520;
     }
     if (s > 0)
     {
           _dos_read(handle, buffer2, s, &byte);
           (*bytes) += byte;
     }

}

void _dos_write_max(int handle, void __far *buffer, long int size,
                    unsigned long int* bytes)
{
     long s;
     void __far *buffer2;
     unsigned int byte;

     buffer2 = buffer;
     s = size;
     (*bytes) = 0;
     while (s > 65520)
     {
           _dos_write(handle, buffer2, 65520, &byte);
           (*bytes) += byte;
           if (byte < 65520) { s = 0; break; }
           buffer2 = (char huge*) ((unsigned long) buffer2 + ((unsigned long)4095 << 16));
           s -= 65520;
     }
     if (s > 0)
     {
           _dos_write(handle, buffer2, s, &byte);
           (*bytes) += byte;
     }

}

void copy_file(short int handle1, short int handle2, long size, char* filename)
{
    unsigned short segment;
    void __far *buffer;
    unsigned long s;
    unsigned long int bytes;
    unsigned long maxmem;

    _dos_allocmem( 0xffff, &segment );
    maxmem = (long) segment << 4;
    _dos_allocmem( segment, &segment );
    buffer = (char huge*) ((unsigned long) segment << 16);

    s = size;
    while (s > maxmem)
    {
         printf("\rCopying %s...%#2i%%  ",filename, 100 - (s * 100 / size));
         _dos_read_max(handle1, buffer, maxmem, &bytes);
         _dos_write_max(handle2, buffer, maxmem, &bytes);
         s -= maxmem;
    }
    if (s > 0)
    {
         _dos_read_max(handle1, buffer, s, &bytes);
         _dos_write_max(handle2, buffer, s, &bytes);
    }
    printf("\rCopying %s... OK\n",filename);
    _dos_freemem( segment );
}
// 
/*
*void insert_in_archive(long pos1, long size)
*{
*    unsigned short segment;
*    void __far *buffer;
*    long s;
*    long copysize;
*    long fl;
*    long spos;
*    unsigned long int bytes;
*    unsigned long maxmem;
*    long counter;
*
*    if (size == 0) return;
*
*    _dos_allocmem( 0xffff, &segment );
*    maxmem = (long) segment << 4;
*    _dos_allocmem( segment, &segment );
*    buffer = (char huge*) ((long) segment << 16);
*
*    counter = maxmem;
*    fl = filelength(arc_handle);
*
*    if (size < 0)
*    {
*       counter = (-counter);
*       spos = pos1;
*    }
*    else
*       spos = fl - maxmem;
*
*    copysize = fl - pos1;
*    s = copysize;
*
*    chsize(arc_handle, fl + size);
*
*    while (s > maxmem)
*    {
*         if (size < 0)
*            printf("\rDeleting gap of %li bytes in archive...%#2i%%  ",(-size), 100 - (s * 100 / copysize));
*         else
*            printf("\rCreating gap of %li bytes in archive...%#2i%%  ",size, 100 - (s * 100 / copysize));
*
*         lseek(arc_handle, spos, SEEK_SET);
*         _dos_read_max(arc_handle, buffer, maxmem, &bytes);
*         lseek(arc_handle, spos + size, SEEK_SET);
*         _dos_write_max(arc_handle, buffer, maxmem, &bytes);
*         s -= maxmem;
*         spos -= counter;
*    }
*    if (s > 0)
*    {
*         lseek(arc_handle, spos, SEEK_SET);
*         _dos_read_max(arc_handle, buffer, s, &bytes);
*         lseek(arc_handle, spos + size, SEEK_SET);
*         _dos_write_max(arc_handle, buffer, s, &bytes);
*    }
*
*    if (size < 0)
*       printf("\rDeleting gap of %li bytes in archive... OK\n",(-size));
*    else
*       printf("\rCreating gap of %li bytes in archive... OK\n",size);
*
*    _dos_freemem( segment );
*}
*/
// 
int create_file(char* filename)
{
    int handle;
    char* pointer;
    char* pointer2;
    char* curdir;

    handle = open(filename, O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, S_IWUSR);
    if (handle == -1)
    {
       curdir = getcwd( NULL, 0 );
       if (filename[0] == '\\' || (filename[1] == ':' && filename[2] == '\\'))
       {
          chdir("\\");
          pointer = strchr(filename,'\\') + 1;
       }
       pointer = filename;
       pointer2 = pointer;
       while ((pointer = strchr(pointer2,'\\')) != NULL)
       {
            *pointer = 0;
            if (chdir(pointer2) != 0)
               if (mkdir(pointer2) != 0)
               {
                  printf("Can't create directory %s for file %s!\n", pointer2, filename);
                  printf("[A]bort, [R]etry, [I]nfluence with large hammer!\n");
                  exit(-1);
               }
            *pointer = '\\';
            pointer2 = pointer+1;
       }
       chdir (curdir);
       handle = open(filename, O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, S_IWUSR);
       if (handle == -1)
       {
          printf("Can't create file %s!\n", filename);
          exit(-1);
       }
    }
    return(handle);

}
// 
char* get_next_file()
{
    short int rc;        /* return code */
    short int pos;
    char* filename;
    char* pointer;

    if (fileinfo.name[0] == 0 || (rc = _dos_findnext( &fileinfo )) != 0)
    {
       if (files_nr > 0)
       {
          rc = _dos_findfirst( *files_to_check, _A_NORMAL, &fileinfo );
          files_to_check++;
          files_nr--;
       }
    }
    if (rc == 0)
    {
       filename = (char *) my_alloc ( 64 );
       filename++;
       pointer = strrchr(*(files_to_check-1),'\\');

       pos = 0;
       if (pointer != NULL)
       {
          pos = (long) (pointer - (*(files_to_check-1)) + 1);
          memcpy(filename, *(files_to_check-1),pos);
       }
       memcpy(filename+pos, fileinfo.name, 13);
       *(filename+pos+13) = 0;
       filename--;
       filename[0] = strlen(filename + 1);
       filename = my_realloc (filename, strlen(filename + 1) + 2);
       return(filename);
    }
    return(NULL);
}
// 
struct filelist_entry* search_entry ()
{
    char* f1;
    char* name1;
    char* name2;
    int len1;
    int len2;
    int i;

    name2 = *cmdpointer;
    len2 =  strlen(name2);
   // name2 = (char*) (strrchr(name2a, '\')+1);
   // len2 -= (name2 - name2a);
    while (filepointer != NULL)
    {
       name1 = (char*) (filepointer->filename+1);
       len1 = strlen(name1)+1;
       for (i=0;i<len2;i++)
       {
           switch(name2[i])
           {
               case '*':
                   if ((f1 = strchr(&name2[i], '.')) == NULL)
                      return(filepointer);
                   i = f1 - &name2[i];
                   if ((f1 = strchr(name1, '.')) == NULL)
                   {
                      if (name2[i+1] == '*') return(filepointer);
                      goto raus;
                   }
                   len1 -= f1 - name1;
                   name1 = f1;
                   break;
               case '?':
                   break;
               default:
                   if (*name1 != name2[i]) goto raus;
           }
           if (len1 == 0) goto raus;
           name1++; len1--;

       }
       if (len1 == 1) return(filepointer);
raus:  filepointer = filepointer->next;
    }
    return(filepointer);
}

struct filelist_entry* get_next_entry ()
{
    if (filepointer == NULL && cmdpointer == NULL)
    {
       filepointer = filelist;
       cmdpointer = files_to_check;
    }
    else if (filepointer != NULL)
       filepointer = filepointer->next;

    do
    {
       if (filepointer == NULL)
       {
          if (*(cmdpointer+1) != NULL)
          {
             filepointer = filelist;
             cmdpointer++;
          }
          else return(NULL);
       }
       if (search_entry() != NULL) return(filepointer);
    }
    while (filepointer == NULL);
    return(filepointer);
}

// 

char exist (char* filename)
{
    short int handle;
    handle = open( filename, O_RDONLY | O_BINARY);
    if (handle != -1)
    {
       close (handle);
       return (1);
    }
    else
    {
       return (0);
    }
}
// 
void open_tmp()
{
    tmp_handle = open(tmp_file, O_WRONLY | O_BINARY | O_TRUNC | O_CREAT, S_IWUSR);
    if (tmp_handle == -1)
    {
       printf("Can't create tmpfile %s!\n", tmp_file);
       exit(-1);
    }
}
// 

void close_arc_handle()
{
    close(arc_handle);
}

void free_dir()
{
    free((char*) (filelist[0].filename));
    free(&filelist[-1]);
}
// 
// 
void save_file_as_entry(char* fn)
{
    static struct filelist_entry* fe1=NULL;
    static struct filelist_entry* fe2=NULL;

        fe1= (struct filelist_entry*) my_alloc (
                                         sizeof(struct filelist_entry));
        if (fe2 == NULL)
        {
           cmdfiles = fe1;
           fe2 = cmdfiles;
        }
        else
        {
           fe2->next = fe1;
           fe2 = fe1;
        }
        fe1->filename = (long) fn;
        fe1->filepos = 0;
        fe1->len = fileinfo.size;
        fe1->date.day = DAY(fileinfo.wr_date);
        fe1->date.month = MONTH(fileinfo.wr_date);
        fe1->date.year = YEAR(fileinfo.wr_date);
        fe1->time.hour = HOUR(fileinfo.wr_time);
        fe1->time.minute = MINUTE(fileinfo.wr_time);
        fe1->time.second = SECOND(fileinfo.wr_time);
        fe1->next = NULL;


}
// 

void get_files()
{
    char *fn;

    while ((fn = get_next_file()) != NULL)
    {
       save_file_as_entry(fn);
    }
    if (cmdfiles == NULL)
    {
       printf("No files.\n"); exit(-2);
    }
}

// 

void read_dir (char* filename)
{
    long dir_size;
    short i;
    short a;
    char* pointer;
    char* arc_name;
    unsigned short ftime;
    unsigned short fdate;

    lseek( arc_handle, -(long) sizeof( struct fileendheader_ ), SEEK_END );
    read( arc_handle, &fileendheader, sizeof( struct fileendheader_ ) );

    if ( memcmp(fileendheader.magic_bytes, magic_bytes_end, sizeof(magic_bytes_end)-1) )
    {
       printf("Not an Elib(tm)-archive! Create a new one? [Y/N]");
       if (get_yes_or_no()) create_new_archive(filename);
       exit(1);
    }

    lseek( arc_handle, fileendheader.filelistheader, SEEK_SET );
    read( arc_handle, &filelistheader, sizeof( struct filelistheader_ ) );

    if ( memcmp(filelistheader.magic_bytes, magic_bytes_list, sizeof(magic_bytes_list)-1) )
    {
       printf("Corrupt filelist-header or not an Elib(tm)-archive!\n");
       exit(-1);
    }

    pointer = cut_of_path(filename);
    arc_name = (char*) my_alloc(strlen(pointer)+2);
    strcpy(arc_name+1, pointer);

    arc_name[0] = strlen(pointer);
    arc_name[arc_name[0] + 1] = 0;
    strupr(arc_name+1);

    filelistheader.len_of_strings += arc_name[0];
    filelistheader.nr_of_files++;

    printf("Processing archive: %s  Size of exec: %li  Nr. of files: %i\n",
           filename, filelistheader.len_of_exec, filelistheader.nr_of_files);

    dir_size = sizeof (struct filelist_entry) * filelistheader.nr_of_files;
    filelist = (struct filelist_entry*) my_alloc (dir_size);

    printf("Reading archive-directory ...");

    lseek( arc_handle, filelistheader.filelist, SEEK_SET);
    read( arc_handle, &filelist[1], dir_size);

    filelist[1].filename = (long) my_alloc ( filelistheader.len_of_strings );

    lseek( arc_handle, filelistheader.filenames, SEEK_SET);
    read( arc_handle, (char*) (filelist[1].filename), filelistheader.len_of_strings);

    filelist[0].filename = (long) arc_name;
    filelist[0].filepos = 0;
    filelist[0].len = filelistheader.len_of_exec;
    filelist[0].next = &filelist[1];

    _dos_getftime( arc_handle, &fdate, &ftime);

    filelist[0].date.day = DAY(fdate);
    filelist[0].date.month = MONTH(fdate);
    filelist[0].date.year = YEAR(fdate);
    filelist[0].time.hour = HOUR(ftime);
    filelist[0].time.minute = MINUTE(ftime);
    filelist[0].time.second = SECOND(ftime);

    pointer = (char*) (filelist[1].filename);
    a = pointer[0];
    pointer[0] = strlen(pointer+1);

    for (i=2; i < filelistheader.nr_of_files; i++)
    {
        pointer += a;
        filelist[i].filename = (long) pointer;
        a = pointer[0];
        pointer[0] = strlen(pointer+1);
        filelist[i-1].next = &filelist[i];
    }
    filelist[i-1].next = NULL;

    atexit(free_dir);
    printf("\r%30c\r",32);
}
// 

void write_directory(char flag)
{
    struct filelist_entry* fe1;
    long s;
    short int i;
    char* pointer;

    fe1 = filelist;

  //  if (flag == UPDATE_OLD_DIR) // Cut off old directory
  //  {
  //     s = 0; // filelistheader.len_of_exec;
  //     for (i=0;i<filelistheader.nr_of_files;i++)
  //     {
  //         s += fe1->len;
  //         fe1 = fe1->next;
  //     }
  //     chsize(arc_handle, s);
  //     fe1 = filelist;
  //  }

    if (flag == UPDATE_OLD_DIR)
    {
       filelistheader.len_of_exec = fe1->len;
       fe1 = fe1->next; // skip archive-name

       filelist = fe1;  // remove archive-name;
       filelistheader.nr_of_files--;
    }

    if (filelistheader.nr_of_files == 0)
    {
       printf("Warning! Empty archive-directory has not been written back!\n");
       return;
    }

    printf("\nWriting archive-directory...");

    lseek(arc_handle, 0, SEEK_END);

    s = tell(arc_handle);  // points now to filelist
    filelistheader.filelist = s;
    s += filelistheader.nr_of_files * sizeof(struct filelist_entry);
                    // points now to filenames
    filelistheader.filenames = s;

    for (i=0;i<filelistheader.nr_of_files;i++)
    {
        pointer = (char*) (fe1->filename);
        pointer[0] += 2;
        fe1->filename = s;
        s += pointer[0];
        write(arc_handle, fe1, sizeof(struct filelist_entry));
        fe1->filename = (long) pointer;
        fe1 = fe1->next;
    }
    filelistheader.len_of_strings = s - filelistheader.filenames;

    fe1 = filelist;
    for (i=0;i<filelistheader.nr_of_files;i++)
    {
        write(arc_handle, (char*) (fe1->filename), ((char*) fe1->filename)[0]);
        fe1 = fe1->next;
    }
    s = tell(arc_handle);
    fileendheader.filelistheader = s;

    write(arc_handle, &filelistheader, sizeof(struct filelistheader_));
    write(arc_handle, &fileendheader, sizeof(struct fileendheader_));

    printf("done!\n");
}
// 
// 

void check_exclude_path(void* fe)
{
     char** filename;
     if (exclude_pathnames == TRUE)
     {
        filename = (char**) fe;
        (*filename) = cut_of_path((*filename) + 1) - 1;
        (**filename) = strlen((*filename) + 1);
     }
}

// 
// 

void create_new_archive(char* filename)
{
    struct filelist_entry* fe1;
    long s;
    short int handle;

    arc_handle = open(filename, O_RDWR | O_BINARY);
    if (arc_handle == -1)
    {
       printf("No write-permission for archive %s!\n", filename);
       exit(-1);
    }

    lseek( arc_handle, -(long) sizeof( struct fileendheader_ ), SEEK_END );
    read( arc_handle, &fileendheader, sizeof( struct fileendheader_ ) );

    if ( !memcmp(fileendheader.magic_bytes, magic_bytes_end, sizeof(magic_bytes_end)-1 ) )
    {
       printf("This IS an Elib(tm)-archive! Add files? [Y/N]");
       if (!get_yes_or_no()) exit(1);
       rebuild_archive('a', filename);
       exit(0);
    }
    memcpy(&fileendheader.magic_bytes, magic_bytes_end, sizeof(magic_bytes_end) );
    memcpy(&filelistheader.magic_bytes, magic_bytes_list, sizeof(magic_bytes_list) );

    filelistheader.len_of_exec = filelength( arc_handle );

    get_files();

    s = filelistheader.len_of_exec;
    fe1 = cmdfiles;

    filelistheader.nr_of_files = 1;

    lseek(arc_handle, 0, SEEK_END);

    while (fe1->next != NULL)
    {
        fe1->filepos = s;
        s += fe1->len;

        handle = open((char*) (fe1->filename+1), O_BINARY | O_RDONLY);
        copy_file(handle, arc_handle, fe1->len, (char*) (fe1->filename+1));
        close(handle);

        check_exclude_path(&(fe1->filename));

        fe1 = fe1->next;
        filelistheader.nr_of_files++;
    }
    fe1->filepos = s;

    handle = open((char*) (fe1->filename+1), O_BINARY | O_RDONLY);
    copy_file(handle, arc_handle, fe1->len, (char*) (fe1->filename+1));
    close(handle);

    check_exclude_path(&(fe1->filename));

    filelist = cmdfiles;

    write_directory(CREATE_NEW_DIR);
}
// 
char cmp_time(struct filelist_entry* fe1)
{
    unsigned long a;
    unsigned long b;

    a = ( ( (unsigned long)
          (_YEAR(fe1->date.year) |
           _MONTH(fe1->date.month) |
           _DAY(fe1->date.day))) << 16) |
           _HOUR(fe1->time.hour) |
           _MINUTE(fe1->time.minute) |
           _SECOND(fe1->time.second);

    b = ((unsigned long) fileinfo.wr_date << 16) |
         (unsigned long) fileinfo.wr_time;

    return(a > b);
   // if (a > b) return(TRUE);
   // return(FALSE);
}
// 
// 
char* get_next_file_p(char cmd)
{
    struct filelist_entry* fe1;
    char* p=NULL;

    if (cmd == 'd')
    {
       fe1 = get_next_entry();
       if (fe1 != NULL)
       {
          p = (char*) fe1->filename;
       }
       return (p);
    }
    else
       return(get_next_file());
}
// 

void rebuild_archive(char cmd, char* filename)
{
    char** flaglist;
    char* p;
    short i;
    short nr_of_files;
    long s;
    int handle;
    struct filelist_entry* fe1;

    arc_handle = open(filename, O_RDWR | O_BINARY);
    if (arc_handle == -1)
    {
       printf("No write-permission for archive %s!\n", filename);
       exit(-1);
    }
    atexit(close_arc_handle);
    read_dir( filename );

    flaglist = (char**) my_alloc(filelistheader.nr_of_files * sizeof(char*) );
    memset(flaglist, 0, filelistheader.nr_of_files * sizeof(char*) );

    while ( ( p = get_next_file_p(cmd) ) != NULL)
    {
        for (i=0;i<filelistheader.nr_of_files;i++)
        {
            if (flaglist[i] == NULL &&

               (memcmp(p + p[0] - ((char*) filelist[i].filename)[0] + 1,
                       (char*) (filelist[i].filename) + 1,
                       ((char*) filelist[i].filename)[0]) == 0) &&

               (cmd == 'd' || (cmp_time(&(filelist[i])) ) ))
            {
               flaglist[i] = p;
               if (update_pathnames == TRUE)
               {
                  free((char*) filelist[i].filename);
                  filelist[i].filename = (long) p;
               }

               filelist[i].date.day = DAY(fileinfo.wr_date);
               filelist[i].date.month = MONTH(fileinfo.wr_date);
               filelist[i].date.year = YEAR(fileinfo.wr_date);
               filelist[i].time.hour = HOUR(fileinfo.wr_time);
               filelist[i].time.minute = MINUTE(fileinfo.wr_time);
               filelist[i].time.second = SECOND(fileinfo.wr_time);

               p = NULL;
               break;
            }
        }
        if (p != NULL)
        {
           if (cmd == 'a' || cmd == 'u')
           {
              save_file_as_entry(p);
           }
           else
              free(p);
        }
    }

    open_tmp();

    s = 0;
    nr_of_files = filelistheader.nr_of_files;

    for (i=0;i<nr_of_files;i++)
    {
        if (flaglist[i] != NULL)  // Freshen / Delete
        {
           if (cmd == 'd' && i != 0)
           {
              printf("%s deleted!\n", (filelist[i].filename)+1);
              if (i == nr_of_files - 1)
                 filelist[i-1].next = NULL;
              else
                 filelist[i-1].next = &filelist[i+1];

              filelistheader.nr_of_files--;
           }
           else if (i == 0 && cmd == 'd')
           {
              printf("Warning! Can't delete exec!\n");
              goto copyunch;
           }
           else
           {
              handle = open( (char*) (flaglist[i] + 1), O_BINARY | O_RDONLY);
              filelist[i].len = filelength(handle);
              filelist[i].filepos = s;
              s += filelist[i].len;
              copy_file(handle, tmp_handle, filelist[i].len, flaglist[i]+1);
              close(handle);
              check_exclude_path(&(flaglist[i]));
           }
        }
        else  // Copy unchanged...
        {
copyunch:  lseek(arc_handle, filelist[i].filepos, SEEK_SET);
           filelist[i].filepos = s;
           s += filelist[i].len;
           copy_file(arc_handle, tmp_handle, filelist[i].len, (char*) (filelist[i].filename)+1);
        }
    }

    free(flaglist);

    if ((cmd == 'a' || cmd == 'u') && cmdfiles != NULL)
    {
       filelist[filelistheader.nr_of_files-1].next = cmdfiles;

       fe1 = cmdfiles;
       while (fe1->next != NULL)
       {
           fe1->filepos = s;
           s += fe1->len;

           handle = open( (char*) (fe1->filename+1), O_BINARY | O_RDONLY);
           copy_file(handle, tmp_handle, fe1->len, (char*) (fe1->filename+1));
           close(handle);

           check_exclude_path(&(fe1->filename));

           fe1 = fe1->next;
           filelistheader.nr_of_files++;
       }
       fe1->filepos = s;

       handle = open((char*) (fe1->filename + 1), O_BINARY | O_RDONLY);
       copy_file(handle, tmp_handle, fe1->len, (char*) (fe1->filename+1));
       close(handle);
       filelistheader.nr_of_files++;

       check_exclude_path(&(fe1->filename));
    }
    close(arc_handle);

    arc_handle = tmp_handle;

    write_directory(UPDATE_OLD_DIR);

    printf("Deleting old archive...\n");
    close(arc_handle);

    remove(filename);
    rename(tmp_file, filename);
}

// 
// 

void list_archive(char* filename)
{
    struct filelist_entry* fe1;

    arc_handle = open(filename, O_RDONLY | O_BINARY);
    atexit( close_arc_handle );

    lseek( arc_handle, -(long) sizeof( struct fileendheader_ ), SEEK_END );
    read( arc_handle, &fileendheader, sizeof( struct fileendheader_ ) );

    if ( memcmp(fileendheader.magic_bytes, magic_bytes_end, sizeof(magic_bytes_end)-1) )
    {
       printf("Not an Elib(tm)-archive!\n");
       printf("[A]bort [R]etry [I]nfluence with large hammer!\n");
       exit(-1);
    }
    read_dir( filename );

    printf("\nFilename            Size            Filepos         Time    Date    \n");
    printf("\n");
    while ((fe1 = get_next_entry()) != NULL)
    {
        printf("%-20s%-16li%-16li%02i:%02i:%02i%02i.%02i.%02i\n",
               (char*) ((fe1->filename)+1), fe1->len,
               fe1->filepos,
               fe1->time.hour, fe1->time.minute,
               fe1->time.second,
               fe1->date.day, fe1->date.month,
               fe1->date.year);
    }
    printf("\n");
}
// 
// 
void extract_entries(char cmd, char* filename)
{
    struct filelist_entry* fe1;
    short int handle;
    char* tmpstring;
    char* p;
    char* thisfile;

    arc_handle = open(filename, O_RDONLY | O_BINARY);
    atexit( close_arc_handle );

    tmpstring = (char*) my_alloc (65);
    read_dir( filename );

    while ((fe1 = get_next_entry()) != NULL)
    {
        thisfile = (char*) ((fe1->filename)+1);
test_again:
        if (exist(thisfile) )
        {               // Is same or newer?
           printf("File already exists! Overwrite? [Y/N]");
           if (!get_yes_or_no())
           {
                printf("OK to extract to a new filename? [Y/N]");
                if (!get_yes_or_no()) continue;
                printf("Please enter filename: ");
                fgets (tmpstring, 64, stdin);
                if ((p = strchr(tmpstring, 10)) != NULL) (*p) = 0;
                thisfile = tmpstring;
                goto test_again;
           }
        }

        if (cmd == 'e')
           handle = create_file(cut_of_path(thisfile) );
        else
           handle = create_file(thisfile);

        lseek(arc_handle, fe1->filepos, SEEK_SET);
        copy_file(arc_handle, handle, fe1->len,thisfile);

        _dos_setftime(handle,
                      _YEAR(fe1->date.year) | _MONTH(fe1->date.month) |
                      _DAY(fe1->date.day),
                      _HOUR(fe1->time.hour) | _MINUTE(fe1->time.minute) |
                      _SECOND(fe1->time.second) );

        close(handle);
    }
    printf("Files extracted!\n");
    free(tmpstring);
}
/*
// 
// 
*
*void extract_exec(char* filename)
*{
*    short int handle;
*
*    arc_handle = open(filename, O_RDONLY | O_BINARY);
*    atexit( close_arc_handle );
*
*    read_dir( filename );
*
*    handle = create_file(*files_to_check);
*    lseek(arc_handle,0, SEEK_SET);
*    copy_file(arc_handle, handle, filelistheader.len_of_exec, *files_to_check);
*    close(handle);
*
*}
// 
// 
*void freshen_exec(char* filename)
*{
*    struct filelist_entry* fe1;
*
*    short int handle;
*    long fl;
*    long diff;
*    short int i;
*
*    if (!exist(*files_to_check))
*    {
*       printf("Cannot open file %s!\n", *files_to_check);
*       exit(-1);
*    }
*
*    arc_handle = open(filename, O_RDWR | O_BINARY);
*    if (arc_handle == -1)
*    {
*       printf("No write-permission for archive %s!\n", filename);
*       exit(-1);
*    }
*    atexit(close_arc_handle);
*
*    read_dir( filename );
*
*    handle = open(*files_to_check, O_RDONLY | O_BINARY);
*    fl = filelength(handle);
*    diff = fl - filelistheader.len_of_exec;
*
*    insert_in_archive(filelistheader.len_of_exec-1, diff);
*    lseek(arc_handle, 0, SEEK_SET);
*    copy_file(handle, arc_handle, fl, *files_to_check);
*
*    fe1 = filelist;
*    for (i=0;i<filelistheader.nr_of_files;i++)
*    {
*        fe1->filepos += diff;
*        fe1 = fe1->next;
*    }
*    filelistheader.len_of_exec = fl;
*
*    write_directory(UPDATE_OLD_DIR);
*}
*/
// 
// 

void badarg()
{
    printf ("Commandline format: ELIB [options] [command] [archive_exe] [files...]\n\n"
            "Valid commands are:\n"
            "\ta   add new entries\n"
            "\td   delete entries\n"
            "\tc   create new archive\n"
            "\te   extract entries\n"
            "\tf   freshen entries\n"
            "\tl   list existing entries\n"
            "\tu   update entries\n"
            "\tx   extract entries with pathnames\n"
            "\nValid options are:\n"
            "\t-e  exclude pathes from names\n"
            "\t-p  update pathnames\n\n");
    exit (1);
}

// 

main( int argc, char *argv[] )
{
    int i;
    setbuf(stdout,NULL);

    printf("Executable-file library-manager  Version 1.02 ALPHA\n");
    printf("Copyright (c) Morbid Soft Inc. 1990, 1995\n\n");

    if (argc < 3) badarg();

    for (i=1;i<argc;i++)
    {
        if (argv[i][0] == '-' || argv[i][0] == '/')
        {
           switch (argv[i][1])
           {
              case 'p':
                 update_pathnames = TRUE;
                 break;
              case 'e':
                 exclude_pathnames = TRUE;
                 break;
              default:
                 printf("Invalid option specified: %s!\n\n", argv[i]);
                 badarg();
           }
           if (i < (argc - 1)) // Remove option from commandline
           {
              memmove(&argv[i], &argv[i+1], argc - i + 1);
           }
           argc--;
        }
    }

    if (!exist(argv[2]))
    {
       printf("Archive %s doesn't exist!\n",argv[2]);
       badarg();
    }
    if (argc > 3) // Filenames specified ?
    {
       files_to_check = &argv[3];
       files_nr = argc-3;

       for (i=0;i<files_nr;i++) strupr(files_to_check[i]);

    }
    else
    {
       files_to_check = &joker_pointer;
       files_nr = 1;
    }

    if (argv[1][1]) goto inv_command;
    switch (argv[1][0])
    {
        case 'u':
        case 'a':
        case 'd':
        case 'f':
           rebuild_archive(argv[1][0], argv[2]);
           break;
        case 'l':
           list_archive(argv[2]);
           break;
        case 'c':
           create_new_archive(argv[2]);
           break;
        case 'e':
        case 'x':
           extract_entries(argv[1][0], argv[2]);
           break;
        default:
inv_command:
           printf ("Invalid command '%s'\n\n", argv[1]);
           badarg();
    }

}
